	org	0x100
	
	;%define	CPU_80386
	;%define	DUMMY
	
start:
	; Initialize the seed values to the same as the C test.
	push	ds
	pop	es
	mov	si, seed
	mov	di, randx
	mov	cx, 0x0010
	rep	movsw
	
	%ifndef	DUMMY
		; Open the output file.
		xor	cx, cx
		mov	dx, filename
		mov ah, 0x3c
		int	0x21
		jc	crash		; Barf and exit if we didn't create the file
		
		mov	bx, ax
	%endif
	
	xor	cx, cx		; Start the count at 0 (loop 65536 times)
	
lp:	push	cx		; Save the loop counter
	%ifndef	DUMMY
		push	bx		; Save the file handle
	%endif
	call	getrand	; Get the next random number
	%ifndef DUMMY
		pop	bx			; Retrieve the file handle
		mov	dx,	randw	; Buffer location
		mov	cx,	0x0004	; Number of bytes
		mov	ah, 0x40	; Write to file
		int	0x21
	%endif
	pop	cx			; Retrieve the loop counter
	loop	lp
	
	; Close the file and quit.
	%ifndef DUMMY
		mov	ah, 0x3e	; Close file
		int	0x21
	%endif
	mov	ax,	0x4c00	; Quit
	int	0x21
	
crash:
	mov	dx,	err
	mov	ah,	0x09
	int	0x21	; print error message
	mov	ax,	0x4c00
	int	0x21	; quit
	
filename:
	%ifdef CPU_80386
		db	'rand-386.bin',0
	%else
		db	'rand8086.bin',0
	%endif
	
err:
	db	'Could not create output file.',0xd,'$'
	
seed:
	dd	0x00112233, 0x44556677, 0x8899AABB, 0xCCDDEEFF
	
	%include "shx-rand.asm"
	