#include <stdio.h>
#include "shx-rand.c"

#define DUMMY

/*Test program for the C implementation of shx-rand. Writes 65536 random      */
/*numbers to a file. (This is nowhere near the period for the function, but I */
/*don't exactly have a yottabyte of disk space handy! 256KB of result data is */
/*plenty for verifying correctness, anyway.) See shx-rand.asm for details.    */

int main(int argc, char argv[])
{
	history[0] = 0x00112233;	/*Test seed value. If both implementations use*/
	history[1] = 0x44556677;	/*the same seed and come up with different    */
	history[2] = 0x8899AABB;	/*results, something's out of whack.          */
	history[3] = 0xCCDDEEFF;
	#ifndef DUMMY
		FILE * fp = fopen("rand-c.bin","wb");
	#endif
	int i;
	uint32_t j;
	for (i = 0; i < 65536; i++)
	{
		j = getrand();
		#ifndef DUMMY
			fwrite((void *) &j, sizeof(uint32_t), 1, fp);
		#endif
	}
	#ifndef DUMMY
		fclose(fp);
	#endif
	return 0;
}
